'use strict';

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var path = _interopDefault(require('path'));

function alias() {
  var options = arguments.length <= 0 || arguments[0] === undefined ? {} : arguments[0];

  return {
    resolveId: function (importee, importer) {
      if (Object.keys(options).length === 0) {
        return null;
      }

      var aliasKeys = Object.keys(options);
      // TODO: We shouldn't have a case of double aliases. But may need to handle that better
      var filteredAlias = aliasKeys.filter(function (value) {
        return importee.indexOf(value) === 0;
      })[0];

      if (!filteredAlias) {
        return null;
      }

      var entry = options[filteredAlias];

      var updatedId = importee.replace(filteredAlias, entry);

      if (updatedId.indexOf('./') === 0) {
        var basename = path.basename(importer);
        var directory = importer.split(basename)[0];

        // TODO: Is there a way not to have the extension being defined explicitly?
        return path.resolve(directory, updatedId) + '.js';
      }

      return updatedId;
    }
  };
}

module.exports = alias;